@tool
extends Node

const custom_shader = preload("./usage_of_custom1.gdshader")

# Called when the node enters the scene tree for the first time.
func _ready():
	# LEFT TRIANGLE
	# Shader set as material on MeshInstance2D
	var mesh = ArrayMesh.new()
	var surface = []
	surface.resize(ArrayMesh.ARRAY_MAX)
	var vertices = PackedVector2Array()
	var custom1 = PackedFloat32Array()

	vertices.push_back(Vector2(0.0, 0.0))
	custom1.append_array([1.0, 0.0, 0.0, 1.0])
	vertices.push_back(Vector2(400.0, 0.0))
	custom1.append_array([0.0, 1.0, 0.0, 0.5])
	vertices.push_back(Vector2(0.0, 400.0))
	custom1.append_array([0.0, 0.0, 1.0, 0.0])

	surface[ArrayMesh.ARRAY_VERTEX] = vertices
	surface[ArrayMesh.ARRAY_CUSTOM1] = custom1
	mesh.add_surface_from_arrays(Mesh.PRIMITIVE_TRIANGLES, surface, [], {}, Mesh.ARRAY_CUSTOM_RGBA_FLOAT << Mesh.ARRAY_FORMAT_CUSTOM1_SHIFT)

	var mesh_instance = MeshInstance2D.new()
	mesh_instance.mesh = mesh
	mesh_instance.material = ShaderMaterial.new()
	mesh_instance.material.shader = custom_shader
	add_child(mesh_instance)

	# RIGHT TRIANGLE
	# Shader set as material on ArrayMesh surface
	# Doesn't look like this is supported in 2D, but at least make sure it doesn't crash.
	mesh = ArrayMesh.new()
	surface = []
	surface.resize(ArrayMesh.ARRAY_MAX)
	vertices = PackedVector2Array()
	custom1 = PackedFloat32Array()

	vertices.push_back(Vector2(0.0, 0.0))
	custom1.append_array([1.0, 0.0, 0.0, 1.0])
	vertices.push_back(Vector2(400.0, 0.0))
	custom1.append_array([0.0, 1.0, 0.0, 0.5])
	vertices.push_back(Vector2(0.0, 400.0))
	custom1.append_array([0.0, 0.0, 1.0, 0.0])

	surface[ArrayMesh.ARRAY_VERTEX] = vertices
	surface[ArrayMesh.ARRAY_CUSTOM1] = custom1
	mesh.add_surface_from_arrays(Mesh.PRIMITIVE_TRIANGLES, surface, [], {}, Mesh.ARRAY_CUSTOM_RGBA_FLOAT << Mesh.ARRAY_FORMAT_CUSTOM1_SHIFT)
	var material = ShaderMaterial.new()
	material.shader = custom_shader
	mesh.surface_set_material(0, material)

	mesh_instance = MeshInstance2D.new()
	mesh_instance.mesh = mesh
	mesh_instance.position = Vector2(500.0, 0.0)
	add_child(mesh_instance)
