@tool
extends Node

const custom_shader = preload("./usage_of_multimesh_with_custom.gdshader")

# Called when the node enters the scene tree for the first time.
func _ready():
	var mesh = ArrayMesh.new()
	var surface = []
	surface.resize(ArrayMesh.ARRAY_MAX)
	var vertices = PackedVector2Array()
	var custom0 = PackedFloat32Array()
	var custom1 = PackedFloat32Array()
	
	vertices.push_back(Vector2(0.0, 0.0))
	custom0.append_array([1.0, 0.0, 0.0, 1.0])
	custom1.append_array([1.0, 0.0, 0.0, 1.0])
	vertices.push_back(Vector2(400.0, 0.0))
	custom0.append_array([0.0, 1.0, 0.0, 0.5])
	custom1.append_array([0.0, 1.0, 0.0, 0.5])
	vertices.push_back(Vector2(0.0, 400.0))
	custom0.append_array([0.0, 0.0, 1.0, 0.0])
	custom1.append_array([0.0, 0.0, 1.0, 0.0])
	
	surface[ArrayMesh.ARRAY_VERTEX] = vertices
	surface[ArrayMesh.ARRAY_CUSTOM0] = custom0
	surface[ArrayMesh.ARRAY_CUSTOM1] = custom1
	mesh.add_surface_from_arrays(
		Mesh.PRIMITIVE_TRIANGLES, surface, [], {},
		(Mesh.ARRAY_CUSTOM_RGBA_FLOAT << Mesh.ARRAY_FORMAT_CUSTOM0_SHIFT) |
		(Mesh.ARRAY_CUSTOM_RGBA_FLOAT << Mesh.ARRAY_FORMAT_CUSTOM1_SHIFT)
	)
	
	var multimesh = MultiMesh.new()
	multimesh.mesh = mesh
	multimesh.transform_format = MultiMesh.TRANSFORM_2D
	multimesh.instance_count = 4
	multimesh.visible_instance_count = 4
	for instance_index in range(0, 4):
		multimesh.set_instance_transform_2d(instance_index, Transform2D().translated(Vector2(instance_index * 500.0, 0.0)))
	
	var multimesh_instance = MultiMeshInstance2D.new()
	multimesh_instance.multimesh = multimesh
	multimesh_instance.material = ShaderMaterial.new()
	multimesh_instance.material.shader = custom_shader
	add_child(multimesh_instance)
